Debian Bug report logs - #294934
RM: daapd -- RoM; Buggy, serious design issue

Package: ftp.debian.org; Maintainer for ftp.debian.org is Debian FTP Master <ftpmaster@ftp-master.debian.org>;

Reported by: Jari Aalto <jari.aalto@cante.net>

Date: Sat, 12 Feb 2005 14:03:06 UTC

Severity: important

Done: Debian Archive Maintenance <ftpmaster@ftp-master.debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, mikey@singingtree.com (Michael A. Dickerson):
Bug#294934; Package daapd. Full text and rfc822 format available.

Acknowledgement sent to Jari Aalto <jari.aalto@cante.net>:
New Bug report received and forwarded. Copy sent to mikey@singingtree.com (Michael A. Dickerson). Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jari Aalto <jari.aalto@cante.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: daapd: Unacceptable server startup time at boot (scanning files takes hours)
Date: Sat, 12 Feb 2005 15:58:03 +0200
Package: daapd
Version: 0.2.3d-4
Severity: important


ENVIRONMENT

    Host A	Host B
    - daapd     - audio files 

   - The connection between A-B is WLAN/11Mbps (effective speed about 2-3Mbps)
     and host A accesses B's direcctories via NFS.
   - Total shared files from B is about 2000-3000 (not counted exactly)

PROBLEM

After starting daapd (for the first time), the whole process just hangs.
I assume it is scanning the files and /etc/init.d/daapd is waiting
it to end.

  Starting DAAP music sharing server: 
  (... and it goes on, on and on)

I killed the process after 2 hours due to lack of indication that the
process would ever end by itself.

Due to this hour(s) long hang up, the daapd is unusable in the
presented environment. I assume it might work with fast 1G ethernet
connections, but that's knot the typical home environment.

SUGGESTION

The daapd code needs restructuring to make it usable in any other
environment than localhost (files at host A). It is not uncommon that
files being too big to fit in server A, the data files are shared
through other hosts (like B in my case).

I haven't looked at the source, but I dare to make some suggestions
for the code flow:

- Do not try to scan all files at startup, but divide the task
  into "chunks":
  
  A. Collect the directories to scan to a LIST. This should be fast.
     (easy recursive task)

  B. Store this LIST to disk as checkpoint X.
     => At this point return ok code to the caller, so that
     calling program can continue (in this case: "/etc/init.d/daapd start"
     process)

  C. Start examining the LIST one DIR at a time.
     => After processing one DIR, write checkpoint to disk and
     serve files collected so far.

  D. Continue repeating C, as long as there are still entries in LIST.

-- System Information:
Debian Release: 3.1
  APT prefers unstable
  APT policy: (500, 'unstable'), (1, 'experimental')
Architecture: i386 (i686)
Kernel: Linux 2.6.9-1-686
Locale: LANG=C, LC_CTYPE=C (charmap=ISO-8859-1) (ignored: LC_ALL set to en_US)

Versions of packages daapd depends on:
ii  libc6                       2.3.2.ds1-20 GNU C Library: Shared libraries an
ii  libgcc1                     1:3.4.3-9    GCC support library
ii  libhowl0                    0.9.8-2      Library for Zeroconf service disco
ii  libid3tag0                  0.15.1b-3    ID3 tag reading library from the M
ii  libstdc++5                  1:3.3.5-8    The GNU Standard C++ Library v3
ii  mdnsresponder               0.9.8-2      Howl Rendezvous/mDNS service respo
ii  zlib1g                      1:1.2.2-4    compression library - runtime

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, mikey@singingtree.com (Michael A. Dickerson):
Bug#294934; Package daapd. Full text and rfc822 format available.

Acknowledgement sent to Philipp Kern <pkern@debian.org>:
Extra info received and forwarded to list. Copy sent to mikey@singingtree.com (Michael A. Dickerson). Full text and rfc822 format available.

Message #10 received at 294934@bugs.debian.org (full text, mbox):

From: Philipp Kern <pkern@debian.org>
To: 294934@bugs.debian.org, 294934-submitter@bugs.debian.org
Subject: Re: aapd: Unacceptable server startup time at boot (scanning files takes hours)
Date: Sun, 22 May 2005 17:22:06 +0200
> I haven't looked at the source, but I dare to make some suggestions
> for the code flow:

Please just start daapd detached from the init script. One might lose  
startup failures, but the delay on boot gets unacceptable when you  
have a large music repository.

Kind regards,
Philipp Kern



Message sent on to Jari Aalto <jari.aalto@cante.net>:
Bug#294934. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, mikey@singingtree.com (Michael A. Dickerson):
Bug#294934; Package daapd. Full text and rfc822 format available.

Acknowledgement sent to Jeroen van Wolffelaar <jeroen@wolffelaar.nl>:
Extra info received and forwarded to list. Copy sent to mikey@singingtree.com (Michael A. Dickerson). Full text and rfc822 format available.

Message #18 received at 294934@bugs.debian.org (full text, mbox):

From: Jeroen van Wolffelaar <jeroen@wolffelaar.nl>
To: 294934@bugs.debian.org
Cc: Debian Bugs Control Bot <control@bugs.debian.org>
Subject: [mikey@singingtree.com: Re: Please remove howl]
Date: Fri, 16 Sep 2005 02:19:11 +0200
reassign 294934 ftp.debian.org
retitle 294934 RM: daapd -- RoM; Buggy, serious design issue
thanks

----- Forwarded message from "Michael A. Dickerson" <mikey@singingtree.com> -----

Date: Tue, 13 Sep 2005 15:59:36 -0700 (PDT)
From: "Michael A. Dickerson" <mikey@singingtree.com>
To: Jeroen van Wolffelaar <jeroen@wolffelaar.nl>
cc: Jeff Waugh <jdub@perkypants.org>, 302462@bugs.debian.org
Subject: Re: Please remove howl
Message-ID: <20050913144951.X46773@redlance.singingtree.com>

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

On Tue, 13 Sep 2005, Jeroen van Wolffelaar wrote:
> Hm, this will break daapd. Michael, are you aware of the state of howl?
> Please be adviced that if this package is removed, daapd will be
> uninstalleable. So please adopt this package and move it to non-free if
> you want to keep daapd installeable.

Let's just drop daapd too; it has at least one design problem that is
non-trivial to fix (see #294934) and it's not clear to me that there is a
future for daapd or howl.

I still use the package, and in case anybody that wanders through here is
interested, it can be found in my local repository at
http://www.dci.pomona.edu/debs.

M.D.
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.2 (FreeBSD)

iD8DBQFDJ1nfQBZkSjT8gWoRArTCAJwNfQbX2NK3tfQWlqvCQuwOdB/njACgyzVf
ETLJoWlxrojCy13Dq3X136E=
=BgO8
-----END PGP SIGNATURE-----



----- End forwarded message -----

-- 
Jeroen van Wolffelaar
jeroen@wolffelaar.nl
http://jeroen.A-Eskwadraat.nl



Bug reassigned from package `daapd' to `ftp.debian.org'. Request was from Jeroen van Wolffelaar <jeroen@wolffelaar.nl> to control@bugs.debian.org. Full text and rfc822 format available.

Changed Bug title. Request was from Jeroen van Wolffelaar <jeroen@wolffelaar.nl> to control@bugs.debian.org. Full text and rfc822 format available.

Reply sent to Debian Archive Maintenance <ftpmaster@ftp-master.debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Jari Aalto <jari.aalto@cante.net>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #27 received at 294934-close@bugs.debian.org (full text, mbox):

From: Debian Archive Maintenance <ftpmaster@ftp-master.debian.org>
To: 294934-close@bugs.debian.org
Cc: daapd@packages.debian.org, daapd@packages.qa.debian.org
Subject: Bug#294934: fixed
Date: Thu, 15 Sep 2005 17:38:07 -0700
We believe that the bug you reported is now fixed; the following
package(s) have been removed from unstable:

     daapd |   0.2.4a-1 | source, alpha, arm, hppa, i386, ia64, m68k, mips, mipsel, powerpc, s390, sparc

Note that the package(s) have simply been removed from the tag
database and may (or may not) still be in the pool; this is not a bug.
The package(s) will be physically removed automatically when no suite
references them (and in the case of source, when no binary references
it).  Please also remember that the changes have been done on the
master archive (ftp-master.debian.org) and will not propagate to any
mirrors (ftp.debian.org included) until the next cron.daily run at the
earliest.

Packages are never removed from testing by hand.  Testing tracks
unstable and will automatically remove packages which were removed
from unstable when removing them from testing causes no dependency
problems.

Bugs which have been reported against this package are not automatically
removed from the Bug Tracking System.  Please check all open bugs and
close them or re-assign them to another package if the removed package
was superseded by another one.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 294934@bugs.debian.org.

This message was generated automatically; if you believe that there is
a problem with it please contact the archive administrators by mailing
ftpmaster@debian.org.

Debian distribution maintenance software
pp.
Jeroen van Wolffelaar (the ftpmaster behind the curtain)



Information forwarded to debian-bugs-dist@lists.debian.org, James Troup and others <ftpmaster@ftp-master.debian.org>:
Bug#294934; Package ftp.debian.org. Full text and rfc822 format available.

Acknowledgement sent to Christopher Bellers <cbellers@intarnet.us>:
Extra info received and forwarded to list. Copy sent to James Troup and others <ftpmaster@ftp-master.debian.org>. Full text and rfc822 format available.

Message #32 received at 294934@bugs.debian.org (full text, mbox):

From: Christopher Bellers <cbellers@intarnet.us>
To: 294934@bugs.debian.org
Subject: You cannot possibly be serious.
Date: Sat, 17 Dec 2005 11:29:51 -0600
You dropped a package from the archive because it takes too long to  
index a large audio library over a slow remote-mounted directory?

Really, thats' pretty ridiculous. Once you install daapd, it begins  
the indexing immediately. Once it's done there's no delay on bootup.

I've had sendmail lock up a box on bootup for 15 minutes because it  
doesn't have a working DNS resolver, but you never see sendmail  
getting taken out of distributions.

Can I file a bux report against Firefox because large pages take to  
long to load on a 28.8 modem?

I'm not sure what use this bug report will be, it's not like you can  
force someone to keep maintaining a package, but I want my extreme  
disgust and displeasure to go on record.
--
CM Bellers
cbellers@intarnet.us




Information forwarded to debian-bugs-dist@lists.debian.org, James Troup and others <ftpmaster@ftp-master.debian.org>:
Bug#294934; Package ftp.debian.org. Full text and rfc822 format available.

Acknowledgement sent to Jeroen van Wolffelaar <jeroen@wolffelaar.nl>:
Extra info received and forwarded to list. Copy sent to James Troup and others <ftpmaster@ftp-master.debian.org>. Full text and rfc822 format available.

Message #37 received at 294934@bugs.debian.org (full text, mbox):

From: Jeroen van Wolffelaar <jeroen@wolffelaar.nl>
To: "Michael A. Dickerson" <mikey@singingtree.com>
Cc: 294934@bugs.debian.org
Subject: [cbellers@intarnet.us: Bug#294934: You cannot possibly be serious.]
Date: Sat, 17 Dec 2005 19:46:00 +0100
This user is a bit unhappy about daapd's removal. If you want to
comment, please go ahead, if only to tell him that if he wants the
package back he may maintain it or something like that -- or that a
dependency had license issues (#289856), and that therefore this package
was no longer maintaineable either.

--Jeroen

----- Forwarded message from Christopher Bellers <cbellers@intarnet.us> -----

Subject: Bug#294934: You cannot possibly be serious.
Reply-To: Christopher Bellers <cbellers@intarnet.us>,
	294934@bugs.debian.org
Resent-From: Christopher Bellers <cbellers@intarnet.us>
Message-Id: <DF2D935D-AE07-4C7A-B666-A5B987D4E2BB@intarnet.us>
To: 294934@bugs.debian.org
From: Christopher Bellers <cbellers@intarnet.us>
Date: Sat, 17 Dec 2005 11:29:51 -0600

You dropped a package from the archive because it takes too long to  
index a large audio library over a slow remote-mounted directory?

Really, thats' pretty ridiculous. Once you install daapd, it begins  
the indexing immediately. Once it's done there's no delay on bootup.

I've had sendmail lock up a box on bootup for 15 minutes because it  
doesn't have a working DNS resolver, but you never see sendmail  
getting taken out of distributions.

Can I file a bux report against Firefox because large pages take to  
long to load on a 28.8 modem?

I'm not sure what use this bug report will be, it's not like you can  
force someone to keep maintaining a package, but I want my extreme  
disgust and displeasure to go on record.
--
CM Bellers
cbellers@intarnet.us



----- End forwarded message -----

-- 
Jeroen van Wolffelaar
Jeroen@wolffelaar.nl (also for Jabber & MSN; ICQ: 33944357)
http://Jeroen.A-Eskwadraat.nl



Information forwarded to debian-bugs-dist@lists.debian.org, James Troup and others <ftpmaster@ftp-master.debian.org>:
Bug#294934; Package ftp.debian.org. Full text and rfc822 format available.

Acknowledgement sent to "Michael A. Dickerson" <mikey@singingtree.com>:
Extra info received and forwarded to list. Copy sent to James Troup and others <ftpmaster@ftp-master.debian.org>. Full text and rfc822 format available.

Message #42 received at 294934@bugs.debian.org (full text, mbox):

From: "Michael A. Dickerson" <mikey@singingtree.com>
To: Jeroen van Wolffelaar <jeroen@wolffelaar.nl>
Cc: 294934@bugs.debian.org
Subject: Re: [cbellers@intarnet.us: Bug#294934: You cannot possibly be serious.]
Date: Sat, 17 Dec 2005 19:17:31 -0800 (PST)
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

On Sat, 17 Dec 2005, Jeroen van Wolffelaar wrote:
> You dropped a package from the archive because it takes too long to
> index a large audio library over a slow remote-mounted directory?
>
> Really, thats' pretty ridiculous. Once you install daapd, it begins
> the indexing immediately. Once it's done there's no delay on bootup.
>
> I've had sendmail lock up a box on bootup for 15 minutes because it
> doesn't have a working DNS resolver, but you never see sendmail
> getting taken out of distributions.
>
> Can I file a bux report against Firefox because large pages take to
> long to load on a 28.8 modem?
>
> I'm not sure what use this bug report will be, it's not like you can
> force someone to keep maintaining a package, but I want my extreme
> disgust and displeasure to go on record.

Hi Christopher, I was the maintainer that put daapd in Debian for a while.
Its removal was discouraging to me too.  I don't have the time to dig up
all the documentation right now, so I am going from memory, and I might
have part of the story wrong.

Mostly, the problem was bickering over some arcane and poorly defined
objections to the Apple ACSL license, which applied to some code that
might possibly have made it into mdnsresponder and/or libhowl (see
#289856).  Some people insisted that mdnsresponder and howl be removed
from the archive, and these people apparently outranked the people that
felt that the license "issues" did not merit removal, so that's what
happened.  There is no free implementation of mDNS that could have
reasonably replaced them for daapd's purposes, so that was effectively the
end of daapd.

The bug you saw (294934) was only mentioned in passing, as part of the
licensing debate.  At that point somebody else filed the RM request and
happened to reference the unimportant bug (294934).  That must be the
reason you got the impression that this was "the" reason I asked for the
package to be removed, but that wasn't the case.

So anyway, it is lame that daapd was forced out, and if you feel that this
kind of amateur license lawyering is a waste of time and destructive to
the Debian project, I would be inclined to agree with you.  Myself, I
still use Debian and Ubuntu, but I no longer attempt to contribute.  I got
tired of writing 1,000 lines of email and overhead (and reading 10,000)
for every 10 lines of actual hacking, so I handed off my other packages
and let my DD application die.  If you've got more time and patience than
I do, by all means, you are welcome to revive the daapd package.

Have fun..
M.D.
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.2 (FreeBSD)

iD8DBQFDpNTRQBZkSjT8gWoRAr/KAKCImP5zKZ5R4NI0R+4zMMfGtaKRSQCgrNM2
A7gdtBhJ1l4ocp0idoc5iz4=
=0+RF
-----END PGP SIGNATURE-----



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 18 Jun 2007 00:05:43 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 20:06:50 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.